<template>
  <VDropdown
    :variant="customVariant"
    dropdown-align="right"
    :v-style="{
      dropdown: (classes, { add, del, replace }) => {
        del('w-full')
      }
    }"
  >
    <template
      #trigger="{
        isShown,
        mousedownHandler,
        focusHandler,
        keydownHandler,
        blurHandler,
        variant: dropdownVariant
      }"
    >
      <!-- Trigger button -->
      <VButton
        :v-style="(classes, { add, del, replace }) => {
          replace('py-1', 'py-{5px}')
        }"
        :variant="dropdownVariant"
        :icon="isShown ? 'sort-up' : 'sort-down'"
        :icon-props="{
          class: {
            'fill-current': true,
            'mt-1': isShown,
            '-mt-2': !isShown
          }
        }"
        icon-position="right"
        @focus.native="focusHandler"
        @keydown.native="keydownHandler"
        @blur.native="blurHandler"
        @click.native.stop="mousedownHandler"
      >
        <template #default>
          <!-- Flag icon -->
          <I18nFlagIcon
            :lang="$app.currentLocale()"
            height="20px"
          />
        </template>
      </VButton>
    </template>
    <template #default="dropdown">
      <VDropdownButton
        v-for="l in LANGS"
        :key="l.lang"
        :dropdown="dropdown"
        class="min-w-content"
        @click="localeClickHandler($event, l.lang)"
      >
        <div class="flex gap-2 items-center">
          <!-- Flag icon -->
          <I18nFlagIcon
            :lang="l.lang"
            class="mr-2"
          />
          <!-- Lang name -->
          <span>{{ LANGS[l.lang].name }}</span>
        </div>
      </VDropdownButton>
    </template>
  </VDropdown>
</template>

<script>
export default {
  name: 'LangDropdown',
  props: {
    variant: {
      type: String,
      default () {
        return undefined
      }
    }
  },
  computed: {
    /**
     * Make variant customizing possible
     * @returns {string} - The variant to set
     */
    customVariant: function () {
      return this.variant || this.$app.ui.isTheme({
        light: 'white-smoke',
        dark: 'mirage'
      })
    }
  },
  methods: {
    /**
     * Set the locale
     * @param {object} evt - The click event
     * @param {string} locale - The target locale
     */
    localeClickHandler (evt, locale) {
      this.$app.setLocale(locale)
    }
  }
}
</script>
